;
;					EJEMPLO 2.12
;
;				Autor: Mikel Etxebarria
;			(c) Microsystems Engineering (Bilbao)
;
;Ejemplo para simulacin y/o MicroPIC Trainer
;
;El Display de 7 segmentos de la MicroPIC Trainer. Decodificador hex. a 7 segmentos.
;
;Mediante los cuatro interruptores RA0-RA3 se introduce un valor hexadecimal de 4 bits
;que debe visualizarse sobre el display de la MicroPIC Trainer
	
		List	p=16F84		;Tipo de procesador
		include	"P16F84.INC"	;Definiciones de registros internos
                    
		org	0x00		;Vector de Reset
		goto	Inicio

		org	0x05		;Salva el vector de interrupcin

;**********************************************************************************
;Tabla: Esta rutina convierte el cdigo binario presente en los 4 bits de menos peso
;del reg. W en su equivalente a 7 segmentos. El cdigo 7 segmentos retorna tambin
;en el reg. W

Tabla:		addwf	PCL,F		;Desplazamiento sobre la tabla
		retlw	b'00111111'	;Dgito 0
		retlw	b'00000110'	;Dgito 1
		retlw	b'01011011'	;Dgito 2
		retlw	b'01001111'	;Dgito 3
		retlw	b'01100110'	;Dgito 4
		retlw	b'01101101'	;Dgito 5
		retlw	b'01111101'	;Dgito 6
		retlw	b'00000111'	;Dgito 7
		retlw	b'01111111'	;Dgito 8
		retlw	b'01100111'	;Dgito 9
		retlw	b'01110111'	;Dgito	A
		retlw	b'01111100'	;Dgito b
		retlw	b'00111001'	;Dgito	C
		retlw	b'01011110'	;Dgito d
		retlw	b'01111001'	;Dgito	E
		retlw	b'01110001'	;Dgito	F

Inicio	        clrf 	PORTB		;Borra los latch de salida
		bsf	STATUS,RP0	;Selecciona banco 1
		clrf	TRISB		;Puerta B se configura como salida
		movlw	b'00011111'		
		movwf	TRISA		;Puerta A se configura como entrada		
		bcf	STATUS,RP0	;Selecciona banco 0			                                                                         

Loop		clrwdt			;Refrescar el WDT
		movf	PORTA,W
		andlw	b'00001111'	;Lee el cdigo de RA0-RA3
		call	Tabla		;Convierte a 7 segmentos
		movwf	PORTB		;Visualiza sobre el display
		goto 	Loop

		end			;Fin del programa fuente

