;
;					EJEMPLO 2.4
;
;				Autor: Mikel Etxebarria
;			(c) Microsystems Engineering (Bilbao)
;
;Ejemplo para simulacin y/o MicroPIC Trainer
;
;Programa combinacional
;                                                                         
;Al valor que se introduce desde los interruptores RA0-RA4 de la puerta A, se le suma la
;constante 5. El resultado se visualiza en los leds RB0-RB7 conectados a la puerta B
;
	
		List	p=16F84		;Tipo de procesador
		include	"P16F84.INC"	;Definiciones de registros internos

		org	0x00		;Vector de Reset
		goto	Inicio

		org	0x05		;Salva el vector de interrupcin

Inicio	        clrf 	PORTB		;Borra los latch de salida
		bsf	STATUS,RP0	;Selecciona banco 1
		clrf	TRISB		;Puerta B se configura como salida
		movlw	b'00011111'		
		movwf	TRISA		;Puerta A se configura como entrada
		bcf	STATUS,RP0	;Selecciona banco 0			

Loop:		clrwdt			;Refrescar el WDT
		movf	PORTA,W		;Carga el estado de las entradas RA0-RA4
		addlw	.5		;Le suma 5
		movwf	PORTB		;Visualiza el resultado en RB0-RB7
		goto	Loop

		end			;Fin del programa fuente
